#include "Wrapper.hxx"
typedef unsigned int size_t; /* appropriate for 32-bit Debian Linux */
extern "C" {
void *malloc(size_t);
void free(void *);
}

NextClass::NextClass(NextClass::ior_t *ior) 
  : BaseClass(ior)
{
  
}

TestClass::TestClass(TestClass::ior_t *ior)
  : BaseClass(ior) 
{
}

TestClass::TestClass(const TestClass &src)
{
  d_self = src.d_self;
  if (d_self) {
    addRef(d_self);
  }
}

TestClass &
TestClass::operator =(const TestClass &rhs)
{
  if (d_self != rhs.d_self) {
    if (d_self) {
      /* segfault at next line because d_self wasn't initialized to 0 */
      deleteRef(d_self);
    }
    d_self = rhs.d_self;
    if (d_self) {
      addRef(d_self);
    }
  }
  return *this;
}

void
Container::add(TestClass &src) {
  if (d_size < 99) {
    d_array[d_size++] = src;
  }
}

TestClass
Container::at(int i) {
  return d_array[i];
}

struct C_Container {
  Container *d_cont;
};

struct C_Container *
createContainer(void)
{
  struct C_Container *result = new C_Container;
  result->d_cont = new Container;
  return result;
}

void
destroyContainer(struct C_Container *cont)
{
  if (cont) {
    delete cont->d_cont;
    delete cont;
  }
}

int
getSize(struct C_Container *cont)
{
  return cont ? cont->d_cont->size() : 0;
}

void
addItem(struct C_Container *cont,
	struct RefCount_t *newItem)
{
  if (cont && newItem) {
    addRef(newItem);
    TestClass tmp(newItem);
    cont->d_cont->add(tmp);
  }
}

struct RefCount_t *
getItem(struct C_Container *cont,
	int ind)
{
  struct RefCount_t *result = 0;
  TestClass _local_result;
  try {
    _local_result = cont->d_cont->at(ind);
  }
  catch(...) {
    return result;
  }
  result = _local_result.getIOR();
  if (result) {
    addRef(result);
  }
  return  result;
}
