#ifndef __WRAPPER_HXX_INCLUDED__
#define __WRAPPER_HXX_INCLUDED__
#include "RefCount.h"
/* extern "C" int printf(const char *,...); */

class BaseClass {
protected:
  struct RefCount_t *d_self;
public:
  BaseClass() : d_self(0) { /* printf("Hello\n"); */ }

  BaseClass(struct RefCount_t *ior) : d_self(ior) {}

  ~BaseClass() {
    if (d_self) {
      deleteRef(d_self);
      d_self = 0;
    }
  }
};


class NextClass : public virtual BaseClass {
public:
  typedef struct RefCount_t ior_t;
  NextClass() {}
  NextClass(ior_t *ior);
};


class TestClass : public virtual NextClass {
public:
  typedef struct RefCount_t ior_t;
  TestClass() {}
  TestClass(ior_t *ior);
  virtual ~TestClass() { }
  TestClass(const TestClass &src);
  TestClass& operator= (const TestClass &rhs);
  ior_t *getIOR() const { return d_self; }
  long getNum() const { return d_self->num; }
};

class Container {
private:
  TestClass d_array[100];
  int d_size;
public:
  Container() : d_size(0) {}
  void add(TestClass &src);

  TestClass at(int i);

  int size() const { return d_size; }
};

struct C_Container;

extern "C" {
struct C_Container *
createContainer(void);

void
destroyContainer(struct C_Container *cont);

int
getSize(struct C_Container *cont);

void
addItem(struct C_Container *cont,
	struct RefCount_t *newItem);

struct RefCount_t *
getItem(struct C_Container *cont,
	int ind);
}

#endif /*  __REFCOUNT_H_INCLUDED__ */
